#pragma semicolon 1

#define PLUGIN_VERSION "1.00"

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <dhooks>

Handle hTeleport;

float emptyVec[3];

ConVar hEnabled;
bool bEnabled;

public Plugin myinfo =  {
	name = "Speeding Tickets",
	author = "Deathknife",
	description = "",
	version = PLUGIN_VERSION,
	url = ""
};

public void OnPluginStart() {
	Handle temp = LoadGameConfigFile("teleport.games");
	
	int offset = GameConfGetOffset(temp, "teleport");
	hTeleport = DHookCreate(offset, HookType_Entity, ReturnType_Unknown, ThisPointer_CBaseEntity, OnTeleport);
	DHookAddParam(hTeleport, HookParamType_VectorPtr);
	DHookAddParam(hTeleport, HookParamType_Unknown);
	DHookAddParam(hTeleport, HookParamType_VectorPtr);
	DHookAddParam(hTeleport, HookParamType_Bool);
	
	hEnabled = CreateConVar("sm_reset_speed_on_tp", "0", "Reset speed (set to 0) on teleport");
	bEnabled = hEnabled.BoolValue;
	HookConVarChange(hEnabled, OnCvarChange);
	
	//Late load
	for (int i = 1; i <= MaxClients;i++) {
		if(IsValidClient(i)) {
			OnClientPutInServer(i);
		}
	}
}

public void OnCvarChange(ConVar cvar, char[] oldvalue, char[] newvalue) {
	bEnabled = hEnabled.BoolValue;
}

public MRESReturn OnTeleport(int pThis, Handle hReturn, Handle:hParams) {
	if(bEnabled && IsValidClient(pThis) && hParams != null && !DHookIsNullParam(hParams, 1)) {
		TeleportEntity(pThis, NULL_VECTOR, NULL_VECTOR, emptyVec);
	}
	
	return MRES_Ignored;
}

public void OnClientPutInServer(int client) {
	DHookEntity(hTeleport, true, client);
}

stock bool IsValidClient(int client, bool bAlive = false) {
	if(client >= 1 && client <= MaxClients && IsClientConnected(client) && IsClientInGame(client) && (bAlive == false || IsPlayerAlive(client))) {
		return true;
	}
	
	return false;
}